#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include "add.h"
#include "subtr.h"
#include "mult.h"
#include "divide.h"

#define SUCCESS 1

extern double add(double val1,double val2);
extern double subtr(double val1,double val2);
extern double mult(double val1,double val2);
extern double divide(double val1,double val2);

int main(int argc, char **argv) {

  int val1,val2,result,retCode;
  char operator;
  
  if (argc != 4) {
    printf("usage: %s val1 operator val2\n",argv[0]);
    exit(-1);
  }

  retCode = sscanf(argv[1],"%i",&val1);
  if (retCode != SUCCESS) {
    printf("first number could not be converted");
    return(errno);
  }
  retCode = sscanf(argv[3],"%i",&val2);
  if (retCode != SUCCESS) {
    printf("second number could not be converted");
    return(errno);
  }
  operator = (argv[2])[0];
  switch (operator) {
  case '+':
    result=add(val1,val2);
    break;
  case '-':
    result=subtr(val1,val2);
    break;
  case '*':
    result=mult(val1,val2);
    break;
  case '/':
    result=divide(val1,val2);
    break;
  default:
    printf("Invalid operator!\n");
    exit(-1);
  }
  printf("result in decimal: %d %c %d = %d\n",val1,operator,val2,result);
  printf("result in octal: 0%o %c 0%o = 0%o\n",val1,operator,val2,result);
  printf("result in hex: 0x%x 0x%c 0x%x = %x\n",val1,operator,val2,result);  
  
}
